using System;
using System.Collections.Generic;
using System.Text;
using ElectronicPhoneBook.BusinessLayer;
using System.Data;
using System.Data.OleDb;
namespace ElectronicPhoneBook.DataAccessLayer
{
    public class DataLayer :BLclass 
    {
        OleDbConnection _myCon = new OleDbConnection("provider=Microsoft.Jet.OLEDB.4.0;Data Source=Information.mdb;");
        OleDbCommand _myCommand ;
        OleDbDataAdapter _myAdap;
        OleDbDataReader _myReader;
        
        public DataTable  LoadGrid()
        {
            DataSet dsMembers = new DataSet();
            try
            {
                _myCon.Open();
                _myCommand = new OleDbCommand("Select Firstname from Members", _myCon);
                _myAdap = new OleDbDataAdapter(_myCommand);
                _myAdap.Fill(dsMembers);
                dsMembers.Tables[0].Columns["Firstname"].ColumnName = "Friends Name";
                dsMembers.Tables[0].TableName = "My Friends";
                return dsMembers.Tables[0];
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                _myCon.Close();
                if (dsMembers != null)
                {
                    dsMembers.Dispose();
                }
            }
        }

        public void SetValuetoBL(string str)
        {
            try
            {
                _myCon.Open();
                _myCommand = new OleDbCommand("SELECT Members.Firstname, Members.Initial, Members.Lastname, Members.Address1, Members.Address2, Members.city, Members.state, Members.zipcode, Members.homephone, Members.mobile, Members.office, Members.birthday, Members.email FROM Members WHERE Firstname='"+str+"'", _myCon);
                _myReader = _myCommand.ExecuteReader();
                if (_myReader != null && _myReader.Read())
                {
                    FirstName       = Convert.ToString(_myReader["Firstname"]);
                    MiddleInitial   = Convert.ToString(_myReader["Initial"]);
                    LastName        = Convert.ToString(_myReader["Lastname"]);
                    Address1        = Convert.ToString(_myReader["Address1"]);
                    Address2        = Convert.ToString(_myReader["Address2"]);
                    City            = Convert.ToString(_myReader["city"]);
                    State           = Convert.ToString(_myReader["state"]);
                    ZipCode         = Convert.ToString(_myReader["zipcode"]);
                    HomePhone       = Convert.ToString(_myReader["homephone"]);
                    MobilePhone     = Convert.ToString(_myReader["mobile"]);
                    work            = Convert.ToString(_myReader["office"]);
                    EmailID         = Convert.ToString(_myReader["email"]);
                    BirthDay        = Convert.ToString(_myReader["birthday"]);
                }
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                _myCon.Close();
                if (_myReader != null)
                {
                    _myReader.Dispose();
                }
            }
        }

        public void SaveAll()
        {
            try
            {
                _myCon.Open();
                _myCommand = new OleDbCommand("INSERT INTO MEMBERS (Firstname, Initial, " +
                    "Lastname, Address1, Address2," +
                "city, state, zipcode, homephone," +
                "mobile, office, birthday, email) VALUES ( '" +
                   FirstName + "','" + MiddleInitial + "','" + LastName + "','" + Address1 + "','" + Address2 + "','" +
                   City + "','" + State + "','" + ZipCode + "','" + HomePhone + "','" + MobilePhone + "','" +
                   work + "','" + BirthDay + "','" + EmailID + "')",_myCon);
                 _myCommand.ExecuteNonQuery();
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                _myCon.Close();
            }
        }

        public void DeleteValue(string str)
        {
            try
            {
                if (str != string.Empty)
                {
                    _myCon.Open();
                    _myCommand = new OleDbCommand("DELETE FROM Members WHERE Firstname='" + str + "'", _myCon);
                    _myCommand.ExecuteNonQuery();
                }
            }
            catch (Exception expMsg)
            {
                throw new Exception("Problem in database connection", expMsg);
            }
            finally
            {
                _myCon.Close();
            }
        }
       
    }
}
